*********************************************************************
* MEMPAK.PRG - PACK DBT FILES
*                                 After SPENCE, 1st Edition

STORE 0 TO PACK_FIELD
STORE "        " TO READ_FILE

CLEAR
@ 10,10 SAY "ENTER FILE NAME FOR MEMO PACK:  " GET READ_FILE
@ 12,10 SAY "ENTER FIELD NUMBER OF MEMO FIELD:  " GET PACK_FIELD
READ
PACK_FILE = TRIM(READ_FILE)

? "MPACK.PRG:  TEST PACK MEMO FIELD ", PACK_FIELD
?? " OF FILE "+PACK_FILE
? "******************************************************"
? "PACKED: ",MEMO_PACK(PACK_FILE, PACK_FIELD)
QUIT

*********************************************************************
*********************************************************************
*         DO THE WORK                                               *
*********************************************************************
*********************************************************************

*   MEMPAK.PRG

*   N.B.  ASSUMES FILE NAME IS ALREADY "TRIMMED"

*   1- CHANGE TYPE OF MEMO FIELD TO NUMERIC
*   2- CREATE INDEX ON THE FIELD
*   3- FOR EACH RECORD, SAVE DBT AND DBF RECORD NUMBERS IN PARALLEL ARRAYS
*   4- CALL MEM_PACK TO DO THE PACK
*   5- CHANGE TYPE BACK TO MEMO
*   6- DELETE THE INDEX FILE
**********************************************

FUNCTION  memo_pack
PARAM     file_name, field_num
PRIVATE   field_name, num_recs, i

? "MEMO_PACKing  >"+FILE_NAME+"<        FIELD #",FIELD_NUM


*   1- CHANGE TYPE OF MEMO FIELD TO NUMERIC
    ? "MEM_PAK:  1:  Change MEMO index to NUMERIC."

    newtype (file_name + ".DBF", field_num, "N")


*   2- CREATE INDEX ON THE FIELD
    ? "MEM_PAK:  2:  INDEX DBT records."

    USE &file_name
    field_name = fieldname(field_num)
    INDEX on &field_name TO &field_name
    num_recs = reccount()

*   3- FOR EACH RECORD, SAVE DBT AND DBF RECORD NUMBERS IN PARALLEL ARRAYS
    * dbf
    PRIVATE dbfs[num_recs]
    * dbt
    PRIVATE dbts[num_recs]

    num_memos = 0
    GOTO TOP

    ? "MEM_PAK:  3:  Evaluate each record for processing."
    FOR i = 1 TO num_recs

*        ? "I=" + str(i)+":  "
*        ?? field_name
*        ?? " = "
*        ?? &field_name

         if &field_name != 0
*           ?? " ************* PROCESS!!"
            num_memos = num_memos + 1
*           ??  num_memos
            dbfs[num_memos] = recno()
            dbts[num_memos] = &field_name
        ENDIF
        SKIP
    NEXT
    * close the data base
    USE

*   4- CALL MEM_PACK TO DO THE PACK
    ? "MEM_PAK:  4:  PACK IT!"
    mem_pak(file_name, field_num, num_memos, dbfs, dbts)

*   5- CHANGE TYPE BACK TO MEMO
    ? "MEM_PAK:  5:  Change MEMO index back to MEMO."
    newtype(file_name+".DBF", field_num, "M")

*   6- DELETE THE INDEX FILE
    ? "MEM_PAK:  6:  Delete the temporary INDEX."
    DELETE FILE &field_name..ntx
RETURN (.T.)
*********************************************************************
* EOF:  MEMPAK.PRG *
