/*******************
* NEWTYPE.C  Change DBASE field type
* 1- Retrieve parameter from CLIPPER
* 2- Open file
* 3- SEEK to required FIELD_REC
* 4- Read it
* 5-Change Type
* 6- Reposition file to start of FIELD_REC
* 7- Write modified FIELD_REC
**********************************************/

#include <fcntl.h>
#include <stdio.h>
/* #include <io.h>   */
#include "dbf.h"
#include "extend.h"

                     D( void display_record_field(FIELD_REC *, char *); )

#define O_RAW  O_BINARY       /* QC2 - BC compatibility */

/***********************
* newtype(char *file, unsigned field_no, char *new_type)
*
*   change field number in given file to this type
******************************************************/
CLIPPER newtype()
{
    char *file;
    unsigned field_no;
    char new_type;
    int handle;
    unsigned start_field;  /* offset into .dbf for this field */
    FIELD_REC field_rec;


/* 1.   Get CLIPPER linkages     */
    file = _parc(1);
    field_no = _parni(2);
    new_type = *_parc(3);

                             D(printf("\nNEWTYPE DEBUG REPORT:");)
                             D(printf("\n\tFILE:        %s",     file);)
                             D(printf("\n\tFIELD No.:   %u",     field_no);)
                             D(printf("\n\tNew TYPE:    %c\n\n", new_type);)


/* 2.   Get file(s)    */

    handle = open(file, O_RDWR|O_RAW);  /* O_RAW == O_BINARY */
    if (handle == -1)
    {                        D(printf("\n**** NEWTYPE:  BAD OPEN ****");)
	_retl(FALSE);
	return;
    }

/* 3.    go to start of required field    */
    start_field = sizeof(DBF_HEAD) +
                  sizeof(FIELD_REC) * (field_no  -  1);

    lseek(handle, (long)start_field, SEEK_SET );

/* 4.  Read field  */

    read(handle, (char *) &field_rec, sizeof(FIELD_REC));

                             D(display_record_field(&field_rec, "BEFORE" );)

/* 5.  Change type */
    field_rec.field_type = new_type;

/* 6.  Reposition file  */
    lseek( handle, (long)start_field, SEEK_SET );

/* 7.  Write changed field data */

    write(handle, (char *) &field_rec, sizeof(FIELD_REC));

                             D(display_record_field(&field_rec, "AFTER" );)

/*  wrap up */
    close(handle);
    _retl(TRUE);
                          D(printf("\n**** NEWTYPE:  RETURN OK ****");)
    return;
}
/******************************************************/

#define FNL fr->len_info.num_size.len
#define FND fr->len_info.num_size.dec
#define FCL fr->len_info.char_len

D( void display_record_field (FIELD_REC *fr, char *type)   )
D( {                                               )
D(    int ii;                                      )
D(    char cc;                                     )
D(    printf("\nNEWTYPE %6s: ", type);             )
D(    printf("Field Name / type / len / (dec): "); )

D(    for (ii=0; ii<11; ii++)                      )
D(         printf("%c",fr->field_name[ii]);        )

D(    printf("  %c",fr->field_type);           )
D(    switch(fr->field_type)                   )
D(    {                                        )
D(        case 'N':                            )
D(        printf("  %d  %d",  FNL, FND);       )
D(        break;                               )

D(        default:                             )
D(        printf("  %d",  FCL);                )
D(        break;                               )
D(    }                                        )
D( }                                           )
/**********************************************************/
/* EOF:  MEWTYPE.C  */
